function H_temp = PSF_exten(L, PSF)
%% PSF_exten extend a PSF to the image size
%      L: size of the input image
%   PSF: the original psf
%
%  ----------------------
% | Code:  Zhouye CHEN   |
% | Email: chen@irit.fr  |
% | Date:  June. 2014    |
%  ----------------------


%% Initialization

[lh1 lh2] = size(PSF);

H_temp=[PSF zeros(size(PSF,1),L(2)-size(PSF,2)) ;...
    zeros(L(1)-size(PSF,1), L(2))];

H_temp = circshift(H_temp,[-floor(lh1/2),-floor(lh2/2)]);

