function [y,variance] = addNoise(x,SNR, seed)
% x : input signal (image: M x N, or vector: M*N x 1)
% SNR: Singal to Noise Ratio
% seed: random number generator seed

% Noise variance, calculated through SNR
Ps = var(x(:));
variance = Ps / 10^(SNR/10);

% Set the state of the random number generator based
% on the seed provided by the input
randn('seed',seed);

% Create the noise element (multiply by standard deviation
% sqrt(Pn))
n = sqrt(variance)*randn(size(x));

% Add noise to the input
y = x + n;