function [x_est, a_est, k] = CsDecADMM(y, H, W, Wt, A, At, imsize, N, mu, alpha, beta, gamma, p, ItMax, tol)
a = zeros(N,1);
r1 = zeros(N,1);
r2 = zeros(imsize);
r20 = [];
lambda1 = r1;
lambda2 = r2;
       
beta1 = beta*2;
inv1 = 1/beta1;
inv2 = 1/(beta1+mu*beta1^2);
k = 0;
while k<ItMax
    temp = r2;
	% step1.1
	z1k = a - lambda1/beta;
	factor = z1k./abs(z1k);
	factor(isnan(factor))=0;
	r1 = factor.*(max(abs(z1k)-1/beta,0.0));          
	% step1.2
    if(p==2)       
        r2_nom = beta*conj(H).*fft2(x_blur_est)-conj(H).*fft2(lambda2);
        r2_denom = 2*alpha + beta*conj(H).*H;
        r2 = real(ifft2(r2_nom./r2_denom));
    else                  
        z2k = r2;
        gz2k = conj(H).*H.*fft2(z2k) + conj(H).*fft2(lambda2)/beta...
            - conj(H).*fft2(reshape(real(Wt(a)),imsize));
        gz2k = real(z2k - gamma*ifft2(gz2k));        
        [r2 ,chi] = prox_lp(gz2k,p,alpha*gamma/beta);  
    end
	% step2 (A is orth)
	a1_Aty = At(y)/mu;
	a1 = inv1*a1_Aty - inv2*At(A(a1_Aty));
	a2_bl = lambda1 + W(lambda2);
	a2 = inv1*a2_bl - inv2*At(A(a2_bl));
	a3_bcz = beta*r1 + beta*W(real(ifft2(H.*fft2(r2))));
	a3 = inv1*a3_bcz - inv2*At(A(a3_bcz));
	a = a1 + a2 + a3; 
           
	x_blur_est = real(reshape(Wt(a),imsize));

	% step3
	lambda1 = lambda1 - beta*(a-r1);
	lambda2 = lambda2 - beta*(x_blur_est-real(ifft2(H.*fft2(r2))));

	MSE_t(k+1) = norm(r2(:)-temp(:),2)/norm(r2);%^2/n;
	fprintf('MSE_t = %.2e\n', MSE_t(k+1));  
	if(MSE_t(k+1)<tol)
        break;
    end
    k = k+1;  
end  
x_est = real(r2);
a_est = a;